﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using Infragistics.Win;
using Infragistics.Win.UltraWinToolbars;

namespace _122624
{
    class MyCreation:IUIElementCreationFilter
    {
        RibbonPinButtonInfo imgInfo;

        public MyCreation(RibbonPinButtonInfo imgInfo)
        {
            // TODO: Complete member initialization
            this.imgInfo = imgInfo;
        }
        #region IUIElementCreationFilter Members

        public void AfterCreateChildElements(UIElement parent)
        {
            if (parent is ButtonToolUIElement && ((ButtonToolUIElement)parent).Tool.GetType().Name == "RibbonPinButtonTool")
            {
                
                ButtonToolUIElement b = parent as ButtonToolUIElement;
                UIElement imgUI = b.ChildElements[0] ;
                ImageAndTextUIElementEx i = new ImageAndTextUIElementEx(b);
                i.Rect = imgUI.Rect;
                i.Image = imgInfo.GetImage(b.ToolbarsManager.Ribbon);
                b.ChildElements.Remove(imgUI);
                b.ChildElements.Add(i);
            }
        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }

        #endregion
    }

    public class RibbonPinButtonInfo : IDisposable
    {
        Image expanded;

        public Image Expanded
        {
            get { return expanded; }
            set { expanded = value; }
        }

        Image colapsed;

        public Image Colapsed
        {
            get { return colapsed; }
            set { colapsed = value; }
        }

        public RibbonPinButtonInfo(Image expanded, Image colapsed)
        {
            this.expanded = expanded;
            this.colapsed = colapsed;
        }

        internal Image GetImage(Ribbon ribbon)
        {
           return ribbon.IsMinimized ? colapsed : expanded;
        }

        #region IDisposable Members

        public void Dispose()
        {
            expanded.Dispose();
            colapsed.Dispose();
        }

        #endregion

        
    }

}
